$(function() {
	var nowimpl = !!Date.now;
	var screen=$('#screen');
	screen.css({
		'background-color': 'red',
		'width':'100%',
		'height':'500px'
	});

	var uris=$('#uris').text().split('\n');
	uris=$(uris).
		map(function(){return this.replace(/^\s+|\s+$/,'')}).
		filter(function(){return this.length>0});

	var time_per_frame=1;
	var time_per_picture=100;
	var time_per_picture_min=16;
	var time_per_picture_max=700;
	var time_per_flash=100;
	var pictures_per_beat=6;
	var pict_loop=5;
	var beat_span=2000;
	var beat_span_max=5000;
	var picts={}; // img element cache
	var key_pressed=0;
	var color_loop=4;

	var debug=false;

	var accept_error=100;
	var key_pressed_time=nowimpl?Date.now():+new Date;
	$('body').keypress(function(e) {
		key_pressed=e.which;
		if(e.which==32) {
			e.preventDefault();
			var now=nowimpl?Date.now():+new Date;
			var diff=now-key_pressed_time;
			if(Math.abs(diff-beat_span) < accept_error)
				diff=(diff+diff+beat_span)/3;
			if(diff < beat_span_max)
				beat_span=diff;
			key_pressed_time=now;
		} else if(e.which==114) { // 'r'
			e.preventDefault();
			uris.sort(function(){return Math.random()-0.5});
			picts={}
		} else if(e.which==113) { // 'q'
			e.preventDefault();
			pictures_per_beat=Math.min(20,pictures_per_beat+1);
		} else if(e.which==119) { // 'd'
			e.preventDefault();
			pictures_per_beat=Math.max(0,pictures_per_beat-1);
		} else if(e.which==100) {
			e.preventDefault();
			debug=!debug;
			$('#debug').toggle(debug);
		} else if(49 <= e.which && e.which <= 57) { // 1-9
			e.preventDefault();
			var n=e.which-48;
			color_loop=n;
		}
	});
	$('body').keyup(function(e) {
		if(e.which==32) {
			e.preventDefault();
			var now=nowimpl?Date.now():+new Date;
			time_per_flash=now-key_pressed_time;
			time_per_picture=(beat_span-time_per_flash)/pictures_per_beat;
			time_per_picture=Math.max(time_per_picture_min,time_per_picture);
			time_per_picture=Math.min(time_per_picture_max,time_per_picture);
		}
	});

	function img_element(uri) {
		if(!picts[uri]) {
			picts[uri]=$('<img>').
				attr('src',uri).
				css('width','100%');
		}
		return picts[uri];
	}

	function choice(arr) {
		return arr[Math.floor(Math.random()*(arr.length+1))];
	}

	var t=0;
	var flash_colors=['#ff0000','#00ff00','#0000ff','#ffffff'];
	var stage=0;
	var flashed=false;
	var flash_count=0;
	function update() {
		var now=((nowimpl?Date.now():+new Date)-key_pressed_time)%beat_span;
		if(debug) $('#debug').html(
			[
				'key: '+key_pressed,
				'time_per_flash: '+time_per_flash,
				'beat_span: '+beat_span,
				'picts/beat: '+pictures_per_beat,
				'picts loop: '+pict_loop,
				'flash loop: '+color_loop,
				'now: '+now,
				'stage: '+stage
			].join('<br>')
		);

		if(now < time_per_flash) {
			if(!flashed) {
				flash_count++;
				flashed=true;
				stage=0;
				screen.empty();
				screen.css('background-color',flash_colors[flash_count%color_loop%flash_colors.length]);
			}
		} else {
			flashed=false;
			if(now-time_per_flash > time_per_picture*stage) {
				stage=(stage+1)%(pict_loop*pictures_per_beat);
				screen.empty();
				$(screen).append(img_element(uris[stage%uris.length]));
			}
		}
	}

	function update_handler() {
		update();
		setTimeout(update_handler,time_per_frame);
	}
	setTimeout(update_handler,time_per_frame);
});
